//+------------------------------------------------------------------+
//|                                            Currency heat map.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string Symbols           = "EURUSD;EURJPY;GBPUSD;GBPJPY;USDJPY";
extern string TimeFrames        = "M1;M5;M15;M30;H1;H4;D1;W1;MN";
extern string Prefix            = "";
extern string Suffix            = "";
extern int    Tenkan            = 9;
extern int    Kijun             = 26;
extern int    Senkou            = 52;
extern color  StrongUp          = LimeGreen;
extern color  WeakUp            = Green;
extern color  NoMove            = DimGray;
extern color  WeakDown          = FireBrick;
extern color  StrongDown        = Red;
extern color  DoesNotExist      = Black;
extern bool   UseMSLineDrawFont = false;
extern int    Window            = 0;
extern int    Corner            = 2;

//
//
//
//
//

string shortName;
int    cpairsLenH;
int    cpairsLenV;
int    shortLength;
int    window;  

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int    ctimesLen;
string cpairsh[];
string cpairsv[];
int    aTimes[];
string FontToUse = "Terminal";

//
//
//
//
//

int init()
{
   if (UseMSLineDrawFont) FontToUse = "MS LIneDraw";

      setUpStrings(cpairsh,cpairsLenH,Symbols);
      if (Corner==2 || Corner==3)
         invertArray(cpairsh);

      //
      //
      //
      //
      //

      TimeFrames = stringUpperCase(StringTrimLeft(StringTrimRight(TimeFrames)));
      if (StringSubstr(TimeFrames,StringLen(TimeFrames)-1,1) != ";")
                       TimeFrames = StringConcatenate(TimeFrames,";");

         //
         //
         //
         //
         //                                   
            
         int s = 0;
         int i = StringFind(TimeFrames,";",s);
         int time;
            while (i > 0)
            {
               string current = StringSubstr(TimeFrames,s,i-s);
               time    = stringToTimeFrame(current);
               if (time > 0) {
                     ArrayResize(aTimes,ArraySize(aTimes)+1);
                                 aTimes[ArraySize(aTimes)-1] = time; }
                                 s = i + 1;
                                     i = StringFind(TimeFrames,";",s);
            }
      ctimesLen = ArraySize(aTimes);
      
   //
   //
   //
   //
   //
   
      shortName   = MakeUniqueName("CHM ","");
      shortLength = StringLen(shortName);
      IndicatorShortName(shortName);
   return(0);
}

//
//
//
//
//

int deinit()
{
   clearObjects();
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   string name;
   int    i,k,t;

//         window = WindowFind(shortName);  
         window = Window;  
   
   //
   //
   //
   //
   //

      for (t = 0; t < cpairsLenH; t++ )
      {
         name = shortName+"t"+t;
         if (ObjectFind(name) == -1)
             ObjectCreate(name,OBJ_LABEL,window,0,0,0,0);
                ObjectSet(name,OBJPROP_XDISTANCE,5);
                ObjectSet(name,OBJPROP_YDISTANCE,15+t*10);
                ObjectSetText(name,cpairsh[t],8,"Arial Bold");
                    ObjectSet(name,OBJPROP_CORNER,Corner);
      }                   
      for (i = 0; i < ctimesLen; i++)
      {
         name = shortName+"h"+i;
         if (ObjectFind(name) == -1)
             ObjectCreate(name,OBJ_LABEL,window,0,0,0,0);
                ObjectSet(name,OBJPROP_XDISTANCE,i*50+75);
                ObjectSet(name,OBJPROP_YDISTANCE,1);
                ObjectSetText(name,timeFrameToString(aTimes[i]),8,"Arial Bold");
                    ObjectSet(name,OBJPROP_CORNER,Corner);
      }
      
   //
   //
   //
   //
   //      

   for (i = 0; i < cpairsLenH; i++)
   for (t = 0; t < ctimesLen;  t++)
   {
      string symbol = Prefix+cpairsh[i]+Suffix;
      double price  = iClose(symbol,aTimes[t],0);
      bool   exist  = true;
         
         if (price == 0) exist = false;
         if (!exist) continue;      
         double spanA = iIchimoku(symbol,aTimes[t],Tenkan,Kijun,Senkou,MODE_SENKOUSPANA,1);
         double spanB = iIchimoku(symbol,aTimes[t],Tenkan,Kijun,Senkou,MODE_SENKOUSPANB,1); 
         double close = iClose(symbol,aTimes[t],1);       
         double high  = MathMax(spanA,spanB);
         double low   = MathMin(spanA,spanB);
         
      //
      //
      //
      //
      //
       
      color  theColor = DoesNotExist;
                  while (true)
                  {
                     if (price > high)                { theColor = StrongUp;   break; }
                     if (price > close)               { theColor = WeakUp;     break; }
                     if (price < high && price > low) { theColor = NoMove;     break; }
                     if (price < low)                 { theColor = StrongDown; break; }
                                                        theColor = WeakDown;   break; 
                  }
            
            //
            //
            //
            //
            //
            
            name = shortName+t+k+i;
            if (ObjectFind(name) == -1)
                  ObjectCreate(name,OBJ_LABEL,window,0,0,0,0);
                  ObjectSet(name,OBJPROP_XDISTANCE,t*50+60);
                  ObjectSet(name,OBJPROP_YDISTANCE,k*5+18+i*10);
                  ObjectSetText(name,"",8,FontToUse,theColor);
                       ObjectSet(name,OBJPROP_CORNER,Corner);
   }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string MakeUniqueName(string first, string rest)
{
   string result = first+(MathRand()%1001)+rest;

   while (WindowFind(result)> 0)
          result = first+(MathRand()%1001)+rest;
   return(result);
}

//
//
//
//
//

void clearObjects()
{
   for (int i = ObjectsTotal(); i>=0; i--)
   {
         string name = ObjectName(i);
         if (StringSubstr(name,0,shortLength) == shortName) ObjectDelete(name);
   }         
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void setUpStrings(string& array[],int& length, string source)
{
   source = stringUpperCase(StringTrimLeft(StringTrimRight(source)));
   if (StringSubstr(source,StringLen(source)-1,1) != ";")
                    source = StringConcatenate(source,";");

   //
   //
   //
   //
   //
   
   int  s = 0;
   int  i = StringFind(source,";",s);
   string current;
      while (i > 0)
      {
         current = StringSubstr(source,s,i-s);
         ArrayResize(array,ArraySize(array)+1);
                     array[ArraySize(array)-1] = current;
                     s = i + 1;
                     i = StringFind(source,";",s);
      }
   length = ArraySize(array);
}

void invertArray(string& array[])
{
   string temp[];
   int    size=ArraySize(array);
      ArrayCopy(temp,array);
      for (int i=0; i<size; i++)
      {
         array[i] = temp[size-i-1];
      }
}